//======================================================================
// Header file
//
// Written for the book Programming Windows CE
// Copyright (C) 1998 Douglas Boling
//======================================================================

#define ID_ICON        1
#define IDC_SIP        10

#ifdef __cplusplus
extern "C"{
#endif 

// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))   

struct decodeUINT {                            // structure associates
    UINT Code;                                 // messages 
                                               // with a function 
    LRESULT (*Fxn)(HWND, UINT, WPARAM, LPARAM);
}; 

#define MYSIPCLS       TEXT ("MyNumPanelWndCls")
#define MYMSG_METHCALL (WM_USER+100)           // Used to pass info

#define GRIPWIDTH      9                       // Width of the gripper
#define FLOATWIDTH     200                     // Width of floating wnd
#define FLOATHEIGHT    100                     // height of floating wnd

#define CXBTNS         5                       // Num columns of buttons
#define CYBTNS         3                       // Num rows of buttons

//
// Local data structure for keypad IM window.
//
typedef struct {
	DWORD dwBtnDnFlags;
	IIMCallback *pIMCallback;
	RECT rectDocked;
	BOOL fMoving;
	POINT ptMovBasis;
	POINT ptMovStart;
	IMINFO imi;
} SIPWNDSTRUCT, *LPSIPWNDSTRUCT;

LRESULT CALLBACK NPWndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK DoCreateSip (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoSetSipInfo (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoPaintSip (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoMouseSip (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DoDestroySip (HWND, UINT, WPARAM, LPARAM);
	
#ifdef __cplusplus
}
#endif 
