@echo off

:main

  rem ----------- Detect OS
  if exist %windir%\system32\ntoskrnl.exe goto os_nt

  goto os_w9x
  rem ----------- Short history
  rem   3:13:AM   09/21/1999 - Finished patcher.bat/nt v1.0r2

  goto end

rem =========================================================================
rem        * * W 9 x * V e r s i o n * *
rem =========================================================================

:os_w9x
  set patchver=W9x
  echo.
  echo PATCHER.BAT/%patchver% v1.1r0 by [therain/uCF] , for ICEDUMP using ID.COM

  rem ----------- List Versions
  if "%1"=="??" goto 1lstver

  rem ----------- [version] [sicedir] [action]

  if "%2"=="" goto 1usage

  rem ----------- Check where am i? 
  if not exist "file_id.diz" cd ..

  rem ----------- Check for ID.COM
  if not exist "patcher\id.com" goto 1notdir

  echo.
  echo Patcher will be applied on SoftICE v%1 for %patchver%
  echo.

  rem ----------- Check if Dumper avail for Sice version x.x
  if not exist %patchver%.%1\icedump goto 1notver
  
  rem ----------- Check WinIce.exe
  if not exist %2\winice.exe goto 1notexe

  copy /y patcher\id.com %2 >nul
  copy /y %patchver%.%1\icedump %2 >nul
  cd %2
  rem ----------- Smart huh!?
  subst A: %2
  rem ----------- Yeah!!!
  A:
  cd\
  if "%3"=="P" goto 1ptchovr
  if "%3"=="R" goto 1restore

  if exist winice.id goto 1ptchcon
  rem ----------- Take a backup
  copy/y winice.exe winice.id >nul
  Id.com
  goto 1killdrv

:1ptchovr
 Echo Backing up 'winice.exe' to 'winice.id' (replacing old .id file)
 copy/y winice.exe winice.id >nul
 Id.com
 goto 1killdrv

:1ptchcon
 Choice backup file 'winice.id' already exist,do you want to overwrite? /C:YNA
 if errorlevel 3 goto 1killdrv
 if errorlevel 2 Id
 if errorlevel 1 goto 1ptchovr
 goto 1killdrv

:1killdrv
  C:
  subst A: /d
  goto 1end

:1restnf
  echo Original file 'winice.id' not found.
  goto 1killdrv

:1restore
  if not exist winice.id goto 1restnf
  echo 'winice.exe' restored using file 'winice.id'
  copy/y winice.id winice.exe>nul
  goto 1killdrv
 
:1lstver
  echo.
  dir /ad /p /b %patchver%.???
  echo.
  goto 1end

:1usage
  echo.
  echo PATCHER [version] [sicedir] [action]
  echo.
  echo  [version] : winice version  (the '.' is not accepted,eg: 400 not 4.00)
  echo  [version] : if '??' specified PATCHER will display all supported versions
  echo  [sicedir] : winice.exe location (eg: c:\siw95)
  echo  [action ] : is optional,if not entered patch/confirm overwrite will take place
  echo  [action ] : 'R' restores original winice.exe
  echo  [action ] : 'P' patch and overwrite backup (winice.id).
  echo.
  echo example:
  echo --------
  echo         PATCHER 400 C:\Siw95
  echo         PATCHER 324 "C:\Program Files\Numega\SoftICE"
  echo.
  goto 1end

:1notver
  echo.
  echo Patcher does'nt support yet this version of SoftICE
  echo.
  goto 1end

:1notdir
  echo.
  echo The patcher must be executed in ICEDUMP dir.
  echo.
  goto 1end

:1notexe
  echo.
  echo Can't find %2\winice.exe
  echo.
  goto 1end

:1end
  set patchver=
  if  not "%2"=="" if exist %2\id.com del %2\id.com
  if  not "%2"=="" if exist %2\icedump. del %2\icedump
  goto end

rem =========================================================================
rem        * * N T * V e r s i o n * * 
rem =========================================================================
:os_nt

  rem ----------- Save current directory
  pushd .

  set patchver=WNT
  set _me=PATCHER.BAT

  echo.
  echo %_me%/%patchver% v1.0r2 by [therain/uCF] , for NTICEDUMP using NTID.EXE
  echo.
  rem ----------- No params? display help
  if "%1"=="" goto 2usage

  rem ----------- Check if Command Extensions are ON
  SETLOCAL ENABLEEXTENSIONS
  if ERRORLEVEL 1 goto 2cmdexer

  rem ----------- Where am i?
  if not exist "file_id.diz" cd ..

  rem ----------- List Versions
  if "%1"=="??" goto 2lstver

  rem ----------- Is NTICE installed?
  if not exist "%windir%\system32\drivers\ntice.sys" goto 2notinst

  rem ----------- Am i in correct dir? ( root of icedump)
  if not exist "patcher\ntid.exe" goto 2notdir

  rem ----------- Check ver.
  if not exist "%patchver%.%1\icedump" goto 2notver
  goto 2patcher
  
  goto 2end

:2notinst
  echo.
  echo Could'nt find NTICE.SYS in '%windir%\SYSTEM32\DRIVERS'
  echo make sure it is installed and try again.
  goto 2end

:2notver
  echo.
  echo Could'nt find version (%1) , try running '%_me% ??' for a version list.
  echo.
  goto 2end

:2notdir
  echo.
  echo %_me% must be run from 'icedump' dir. or 'patcher\' dir.
  goto 2end

:2usage
  echo.
  echo PATCHER [version] [xtraopt]
  echo.
  echo  [version] : NTICE version (of this format: XYY,eg: 400,323,...)
  echo  [version] : '??' PATCHER will display all supported versions
  echo  [xtraopt] : 'T' don't take backup file.
  echo  [xtraopt] : 'R' restores backup.
  echo  [xtraopt] : 'O' patch and overwrite existing backup.

  echo.
  echo example:
  echo --------
  echo         PATCHER 400 t
  echo         PATCHER 324 r
  echo         PATCHER 323 O
  echo.
  goto 2end

:2cmdexer
  echo.
  echo %_me% can't run while commands extensions are disabled.
  echo.
  goto 2end

:2lstver
  echo.
  set ltmp=Avail NTIceDump images
  dir /ad /b %patchver%.* > "%ltmp%"
  find /I "%patchver%." "%ltmp%" | more
  del  "%ltmp%"
  goto 2end

:2rest
  if not exist %ftmp%.%1 goto 2restnf
  copy %ftmp%.%1 %ftmp% > nul
  echo Restored NTICE.SYS using NTICE.SYS.%1
  goto 2end

:2restnf
  echo.
  echo Can't restore: '%ftmp%.%1' not found.
  goto 2end

:2patcher

  set ltmp=%windir%\system32\drivers
  set ftmp=%ltmp%\ntice.sys

  rem ----------- Wanna restore?
  if /I "%2"=="R" goto 2rest

  rem ----------- check for backups
  if  exist %ftmp%.%1 if /I not "%2"=="O" goto 2ptchcon

  copy %patchver%.%1\icedump %ltmp% >nul
  copy patcher\ntid.exe %ltmp%  >nul

  %systemdrive%
  pushd .
  cd %ltmp%
  if /I not "%2"=="T" copy ntice.sys ntice.sys.%1 >nul
  ntid.exe
  del icedump
  del ntid.exe
  popd
  goto 2end

:2ptchcon
 echo.
 echo %_me% has detected a previous backup (%1).
 echo re-run using 'O' as extra param to Overwrite backup file
 goto 2end

:2end
  rem ----------- Clear some env. vars.
  set patchver=
  set _me=
  set ltmp=
  set ftmp=

  rem ----------- End localization
  ENDLOCAL

  rem ----------- Pop saved dir.
  popd

  goto end

:end
  rem ----------- The end.
